/*
 * @Author: Caow
 * @Date: 2020-01-14 18:22:10
 * @Last Modified by: Caven
 * @Last Modified time: 2020-07-29 16:36:42
 */

const install = function (BC) {
  if (!BC || !BC.init) {
    throw new Error('Mapv: Missing BC Base')
  }

  if (!BC.ready) {
    throw new Error('Mapv: Missing BC Core')
  }
  BC.init(() => {
    let mapv = require('./mapv.min')
    BC.Namespace['mapv'] = mapv
    BC.MapvDataSet = mapv?.DataSet
    require('./Mapv.Loader')
  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.BC) {
  install(BC)
}

module.exports = {
  version: __VERSION__,
  compile_time: __TIME__,
  install
}
