/**
 *@Author: Caow
 * @Date: 2020-02-02 15:55:53
 */

const install = function(BC) {
  if (!echarts) {
    throw new Error('Chart: missing charts lib')
  }

  if (!BC || !BC.init) {
    throw new Error('Chart: Missing BC Base')
  }

  if (!BC.ready) {
    throw new Error('Chart: Missing BC Core')
  }

  BC.init(() => {
    require('./Chart.Loader')
  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.BC) {
  install(window.BC)
}

export default {
  install
}
