/**
 *@Author: Caow
 * @Date: 2020-04-09 20:02:37
 */

const install = function(BC) {
  if (!BC || !BC.init) {
    throw new Error('Plot: Missing BC Base')
  }

  if (!BC.ready) {
    throw new Error('Plot: Missing BC Core')
  }

  BC.init(() => {
    require('./Overlay.Loader')
  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.BC) {
  install(window.BC)
}

export default {
  version: __VERSION__,
  compile_time: __TIME__,
  install
}
