/**
 * @Author: Caow
 * @Date: 2020-04-03 19:13:42
 */

const install = function(BC) {
  if (!BC || !BC.init) {
    throw new Error('Plot: Missing BC Base')
  }

  if (!BC.ready) {
    throw new Error('Plot: Missing BC Core')
  }

  BC.init(() => {
    require('./Plot.Loader')
  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.BC) {
  install(window.BC)
}

export default {
  install
}
