/**
 *@Author: Caow
 * @Date: 2020-01-14 18:22:10
 */

const install = function(BC) {
  if (!BC || !BC.init) {
    throw new Error('Plugins: Missing BC Base')
  }

  if (!BC.ready) {
    throw new Error('Plugins: Missing BC Core')
  }

  BC.init(() => {
    try {
      require('./Plugins.Loader')
    }catch (e){
      console.log(e)
    }

  })
}

/* istanbul ignore if */
if (typeof window !== 'undefined' && window.BC) {
  install(BC)
}

export default {
  install
}
